// A COMPLETER

/*
Service permettant de chornomtrer jusqu' 59mn 59s 99 1/100
Utilise un timer au choix (TIMER1  TIMER4).
Utilise la lib MyTimers.h /.c
*/



#include "Chrono.h"
#include "MyTimer.h"

// variable prive de type Time qui mmorise la dure mesure
static Time Chrono_Time; // rem : static rend la visibilit de la variable Chrono_Time limite  ce fichier 

// variable prive qui mmorise pour le module le timer utilis par le module
static TIM_TypeDef * Chrono_Timer=TIM1; // init par dfaut au cas o l'utilisateur ne lance pas Chrono_Conf avant toute autre fct.

// dclaration callback appel toute les 10ms
void Chrono_Task_10ms(void);

/**
	* @brief  Configure le chronomtre. 
  * @note   A lancer avant toute autre fonction.
	* @param  Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
  * @retval None
  */
void Chrono_Conf(TIM_TypeDef * Timer)
{
	// Reset Time
	Chrono_Time.Hund=0;
	Chrono_Time.Sec=0;
	Chrono_Time.Min=0;
	
	// Fixation du Timer
	Chrono_Timer=Timer;

	// Rglage Timer pour un dbordement  10ms
	MyTimer_Conf(Chrono_Timer,999, 719);
	
	// Rglage interruption du Timer avec callback : Chrono_Task_10ms()
	MyTimer_IT_Conf(Chrono_Timer, Chrono_Task_10ms,3);
	
	// Validation IT
	MyTimer_IT_Enable(Chrono_Timer);
	
	
}


/**
	* @brief  Dmarre le chronomtre. 
  * @note   si la dure dpasse 59mn 59sec 99 Hund, elle est remise  zro et repart
	* @param  Aucun
  * @retval Aucun
  */
void Chrono_Start(void)
{
	MyTimer_Start(Chrono_Timer);
}


/**
	* @brief  Arrte le chronomtre. 
  * @note   
	* @param  Aucun
  * @retval Aucun
  */
void Chrono_Stop(void)
{
	MyTimer_Stop(Chrono_Timer);
}


/**
	* @brief  Remet le chronomtre  0 
  * @note   
	* @param  Aucun
  * @retval Aucun
  */
void Chrono_Reset(void)
{
  // Arrt Chrono
	MyTimer_Stop(Chrono_Timer);

	// Reset Time
	Chrono_Time.Hund=0;
	Chrono_Time.Sec=0;
	Chrono_Time.Min=0;
}


/**
	* @brief  Renvoie l'adresse de la variable Time prive gre dans le module Chrono.c
  * @note   
	* @param  Aucun
  * @retval adresse de la variable Time
  */
Time * Chrono_Read(void)
{
	return &Chrono_Time;
}




/**
	* @brief  incrmente la variable prive Chron_Time modulo 60mn 
  * @note   
	* @param  Aucun
  * @retval Aucun
  */
void Chrono_Task_10ms(void)
{ 
	Chrono_Time.Hund++;
	if (Chrono_Time.Hund==100)
	{
		Chrono_Time.Sec++;
		Chrono_Time.Hund=0;
	}
	if (Chrono_Time.Sec==60)
	{
		Chrono_Time.Min++;
		Chrono_Time.Sec=0;
	}
	if (Chrono_Time.Min==60)
	{
		Chrono_Time.Hund=0;
	}
	
}


